package test.jeff.com.camera;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;

public class Camera extends Activity
{
    private android.hardware.Camera mCamera;
    private CameraPreview mPreview;
    private long mTime=0;
    private TextView mFPS;
    private List<Float> mListFPS=new ArrayList<Float>();
    private View mShowView;
    private ImageView mImageView;
    //private float[] mFPSBUF = new float[5];
    private int mFlag=0;
    static private int mCameraId=0;
    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_camera);
        mFPS = (TextView)findViewById(R.id.m_fps);


        mTime = System.currentTimeMillis();

        mCameraId= getIntent().getIntExtra("camera_id",0);
        Log.e("ZHANGZEYUAN","====================>>>>mCameraId="+mCameraId);
        mCamera = getCameraInstance();
        int flag = getIntent().getIntExtra("camera_size",0);
        int w = 0;
        int h=0;
        mFlag = flag;
        if(flag==0)
        {
            w=320;
            h=240;
        }else if(flag==1)
        {
            w=640;
            h=480;
        }
        else if(flag==2)
        {
            w=1280;
            h=720;
        }
        else if(flag==3)
        {
            w=1920;
            h=1080;
        }
        mPreview = new CameraPreview(this, mCamera,w,h);
        FrameLayout preview = (FrameLayout) findViewById(R.id.camera_preview);
        preview.addView(mPreview);
        mCamera.setPreviewCallback(mPreviewCallback);

        Button captureButton = (Button) findViewById(R.id.button_capture);
        captureButton.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v)
            {

                Log.e("ZHANGZEYUAN","=====================>>>Take(1)");

                mCamera.takePicture(null, null, mPicture);

            }
        });

    }

    private float getFPS(float fps)
    {
        if(mListFPS.size()>=9)
        {
            mListFPS.remove(0);
            mListFPS.add(fps);

        }else
        {
            mListFPS.add(fps);
        }
         float temp=0;
         for (int i =0;i<mListFPS.size();i++)
         {
             temp+= mListFPS.get(i);
         }

         return (temp)/(float)(mListFPS.size());

    }

    private final android.hardware.Camera.PreviewCallback mPreviewCallback = new android.hardware.Camera.PreviewCallback()
    {
        @Override
        public void onPreviewFrame(byte[] bytes, android.hardware.Camera camera)
        {

            float fps = 1000.0f/(float) (System.currentTimeMillis()-mTime);
            mFPS.setText(getFPS(fps)+"");
            mTime = System.currentTimeMillis();

        }


    };



    private boolean checkCameraHardware(Context context)
    {
        if (context.getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA))
        {
            return true;
        }
        else
        {
            return false;
        }
    }


    public static android.hardware.Camera getCameraInstance() {
        android.hardware.Camera c = null;
        try
        {
            c = android.hardware.Camera.open(mCameraId);
        } catch (Exception e)
        {

        }

        return c;
    }

    public static Bitmap getLoacalBitmap(String url) {
        try {
            FileInputStream fis = new FileInputStream(url);
            return BitmapFactory.decodeStream(fis);  ///把流转化为Bitmap图片

        } catch (FileNotFoundException e) {
            e.printStackTrace();
            return null;
        }
    }
    private void show_photo(String path)
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(Camera.this);
        LayoutInflater mLayoutInflater = getLayoutInflater();
        mShowView = mLayoutInflater.inflate(R.layout.show_take_photo,null);
        mImageView = (ImageView)mShowView.findViewById(R.id.m_show_photo);
        mImageView.setImageBitmap(getLoacalBitmap(path));

        builder.setView(mShowView);
        AlertDialog dialog = builder.create();

        dialog.show();
        WindowManager.LayoutParams params =dialog.getWindow().getAttributes();

        if(mFlag==0)
        {
            params.width = 320;
            params.height = 240 ;
        }else if(mFlag==1)
        {
            params.width = 640;
            params.height = 480 ;
        }
        else if(mFlag==2)
        {
            params.width = 1280;
            params.height = 720 ;
        }
        else if(mFlag==3)
        {
            params.width = 1920;
            params.height = 1080 ;
        }



        dialog.getWindow().setAttributes(params);


    }

    private final Handler mHandler = new Handler()
    {
        @Override
        public void handleMessage(Message msg)
        {
             if(msg!=null)
             {
                 if(msg.what==0xF0)
                 {
                     byte[] data = (byte[])msg.obj;
                     String file_name = "/sdcard/" + System.currentTimeMillis()+ ".jpg";
                     File pictureFile = new File(file_name);
                     try
                     {
                         FileOutputStream fos = new FileOutputStream(pictureFile);
                         fos.write(data);
                         fos.close();
                         Log.e("ZHANGZEYUAN","=====================>>>Take(3) len="+data.length);
                         Toast.makeText(Camera.this,"存储路径："+file_name,Toast.LENGTH_LONG).show();
                         show_photo(file_name);
                     } catch (Exception e)
                     {

                     }
                 }

             }
        }
    };




    private android.hardware.Camera.PictureCallback mPicture = new android.hardware.Camera.PictureCallback() {

        @Override
        public void onPictureTaken(byte[] data, android.hardware.Camera camera)
        {
            Log.e("ZHANGZEYUAN","=====================>>>Take(2)");

            Message message = new Message();
            message.what=0xF0;
            message.obj = data;
            mHandler.sendMessage(message);

        }
    };

    @Override
    protected void onDestroy()
    {

        if(mCamera!=null)
        {
            mCamera.stopPreview();
            mCamera.release();
            mCamera=null;
        }
        super.onDestroy();
    }
}
