package test.jeff.com.camera;

import android.content.Context;
import android.hardware.Camera;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

import java.io.IOException;


public class CameraPreview extends SurfaceView implements SurfaceHolder.Callback {
    private static final String TAG = "main";
	private SurfaceHolder mHolder;
    private Camera mCamera;
    private Camera.Parameters mParameters;
    private int mW = 640;
    private int mH = 480;
    public CameraPreview(Context context, Camera camera,int w,int h) {
        super(context);
        mCamera = camera;
        mW = w;
        mH = h;

        mHolder = getHolder();

        mHolder.addCallback(this);
         mHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }

    public void surfaceCreated(SurfaceHolder holder) {

        try {

        	mCamera.setPreviewDisplay(holder);
            mParameters = mCamera.getParameters();

            mParameters.setPreviewSize(mW,mH);
            mParameters.setPictureSize(mW,mH);
            mCamera.setParameters(mParameters);
           // mCamera.startPreview();
        } catch (IOException e) {

        }
    }

    public void surfaceDestroyed(SurfaceHolder holder) {

    }

    public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {

        if (mHolder.getSurface() == null){

          return;
        }

/*
        try {
            mCamera.stopPreview();
        } catch (Exception e){

        }*/


        try {
            mCamera.setPreviewDisplay(mHolder);

            mCamera.startPreview();

        } catch (Exception e){

        }
    }
}
