package test.jeff.com.camera;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;

import java.util.ArrayList;
import java.util.List;

public class CameraSizeSelect extends Activity
{
    private Button mButton240;
    private Button mButton480;
    private Button mButton720;
    private Button mButton1080;
    private Spinner mSpinner;
    private List<String> mList = new ArrayList<String>();
    private ArrayAdapter<String> adapter;


    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_camera_size_select);
        mSpinner = (Spinner)findViewById(R.id.m_camera_num);
        mSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                selectNewCamera(i);
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });



        mButton240 = (Button)findViewById(R.id.m_camera_240);
        mButton240.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CameraSizeSelect.this,Camera.class);
                intent.putExtra("camera_id",MainActivity.mCameraId);
                intent.putExtra("camera_size",0);
                startActivity(intent);
            }
        });
        mButton480 = (Button)findViewById(R.id.m_camera_480);
        mButton480.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CameraSizeSelect.this,Camera.class);
                intent.putExtra("camera_id",MainActivity.mCameraId);
                intent.putExtra("camera_size",1);
                startActivity(intent);
            }
        });
        mButton720 = (Button)findViewById(R.id.m_camera_720);
        mButton720.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CameraSizeSelect.this,Camera.class);
                intent.putExtra("camera_id",MainActivity.mCameraId);
                intent.putExtra("camera_size",2);
                startActivity(intent);
            }
        });
        mButton1080 = (Button)findViewById(R.id.m_camera_1080);
        mButton1080.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CameraSizeSelect.this,Camera.class);
                intent.putExtra("camera_id",MainActivity.mCameraId);
                intent.putExtra("camera_size",3);
                startActivity(intent);
            }
        });

    }

    private void isSupport(List<android.hardware.Camera.Size> list,Button bt,int w,int h)
    {
        boolean flag =false;
        for (int i=0;i<list.size();i++)
        {
            Log.e("ZHANGZEYUAN","================>>Index="+i+" ,W="+list.get(i).width+" ,H="+list.get(i).height);
            if(list.get(i).height == h && list.get(i).width==w)
            {
                flag=true;
                break;
            }
        }
        if(flag)
        {
            bt.setVisibility(View.VISIBLE);
        }
        else
        {
            bt.setVisibility(View.INVISIBLE);
        }


    }

    private void selectNewCamera(int num)
    {
        try
        {
            MainActivity.mCameraId=num;
            android.hardware.Camera camera = android.hardware.Camera.open(num);
            if(camera!=null)
            {
                List<android.hardware.Camera.Size> mList=camera.getParameters().getSupportedPreviewSizes();
                if(mList!=null&&mList.size()>0)
                {
                    isSupport(mList,mButton240,320,240);
                    isSupport(mList,mButton480,640,480);
                    isSupport(mList,mButton720,1280,720);
                    isSupport(mList,mButton1080,1920,1080);
                }
                else
                {
                    mButton240.setVisibility(View.INVISIBLE);
                    mButton480.setVisibility(View.INVISIBLE);
                    mButton720.setVisibility(View.INVISIBLE);
                    mButton1080.setVisibility(View.INVISIBLE);
                }

                camera.release();
                camera=null;
            }
        } catch (Exception e)
        {
            mButton240.setVisibility(View.INVISIBLE);
            mButton480.setVisibility(View.INVISIBLE);
            mButton720.setVisibility(View.INVISIBLE);
            mButton1080.setVisibility(View.INVISIBLE);
        }
    }

    @Override
    public void onResume()
    {
        try
        {
            mButton240.setVisibility(View.INVISIBLE);
            mButton480.setVisibility(View.INVISIBLE);
            mButton720.setVisibility(View.INVISIBLE);
            mButton1080.setVisibility(View.INVISIBLE);
            mList.clear();
            int num = android.hardware.Camera.getNumberOfCameras();
            Log.e("ZHANGZEYUAN","==================>>CAMERA="+num);
            if(num==0)
            {
                mList.add("Have No Camera");
                adapter=new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mList);
                adapter.setDropDownViewResource(android.R.layout.simple_spinner_item);
                mSpinner.setAdapter(adapter);
                return;
            }
            if(num>0)
            {
                for (int i =0;i<num;i++)
                {
                    mList.add("Camera"+i);
                }
                adapter=new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mList);
                adapter.setDropDownViewResource(android.R.layout.simple_spinner_item);
                mSpinner.setAdapter(adapter);
            }
            mSpinner.setSelection(MainActivity.mCameraId);
            android.hardware.Camera camera = android.hardware.Camera.open(MainActivity.mCameraId);
            if(camera!=null)
            {
                List<android.hardware.Camera.Size> mList=camera.getParameters().getSupportedPreviewSizes();
                if(mList!=null&&mList.size()>0)
                {
                    isSupport(mList,mButton240,320,240);
                    isSupport(mList,mButton480,640,480);
                    isSupport(mList,mButton720,1280,720);
                    isSupport(mList,mButton1080,1920,1080);
                }
                else
                {
                    mButton240.setVisibility(View.INVISIBLE);
                    mButton480.setVisibility(View.INVISIBLE);
                    mButton720.setVisibility(View.INVISIBLE);
                    mButton1080.setVisibility(View.INVISIBLE);
                }

                camera.release();
                camera=null;
            }
         } catch (Exception e)
        {
            mButton240.setVisibility(View.INVISIBLE);
            mButton480.setVisibility(View.INVISIBLE);
            mButton720.setVisibility(View.INVISIBLE);
            mButton1080.setVisibility(View.INVISIBLE);
        }

        super.onResume();
    }

    @Override
    public void onPause()
    {
        super.onPause();
    }




}
