package test.jeff.com.camera;

import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioRecord;
import android.media.AudioTrack;
import android.media.MediaRecorder;

public class RecordThread extends Thread {

    private boolean isRun=true;
    static final int frequency = 44100;
    static final int channelConfiguration = AudioFormat.CHANNEL_CONFIGURATION_STEREO;
    static final int audioEncoding = AudioFormat.ENCODING_PCM_16BIT;
    private AudioRecord audioRecord;
    private AudioTrack audioTrack;
    private int recBufSize;
    private int plyBufSize;
    public RecordThread()
    {
        isRun=true;
        recBufSize = AudioRecord.getMinBufferSize(frequency,
                channelConfiguration, audioEncoding)*2;
        plyBufSize = AudioTrack.getMinBufferSize(frequency,
                channelConfiguration, audioEncoding)*2;

        audioRecord = new AudioRecord(MediaRecorder.AudioSource.MIC, frequency,
                channelConfiguration, audioEncoding, recBufSize);

        audioTrack = new AudioTrack(AudioManager.STREAM_MUSIC, frequency,
                channelConfiguration, audioEncoding, plyBufSize, AudioTrack.MODE_STREAM);
    }

    @Override
    public void run() {
        // TODO Auto-generated method stub


        byte[] recBuf = new byte[recBufSize];
        audioRecord.startRecording();
        audioTrack.play();
        while(isRun)
        {
            int readLen = audioRecord.read(recBuf, 0, recBufSize);
            audioTrack.write(recBuf, 0, readLen);
        }
        audioTrack.stop();
        audioRecord.stop();
    }

    public void stopAudio()
    {
        isRun = false;
    }
}
